unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  MMServer, StdCtrls, ExtCtrls, ComCtrls, ScktComp, Menus;

type
  TMMHeader=Array[0..3] of byte;
  TForm1 = class(TForm)
    ServerSocket: TServerSocket;
    PopupMenu1: TPopupMenu;
    Disconnect1: TMenuItem;
    Panel1: TPanel;
    Panel3: TPanel;
    Memo1: TMemo;
    Panel4: TPanel;
    Edit1: TEdit;
    btnSend: TButton;
    Panel5: TPanel;
    ListView: TListView;
    Panel2: TPanel;
    ComboBox1: TComboBox;
    Panel6: TPanel;
    MMServer1: TMMServer;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    TrackBar1: TTrackBar;
    TrackBar2: TTrackBar;
    Button5: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure TrackBar2Change(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure ServerSocketClientConnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ServerSocketClientDisconnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ServerSocketClientError(Sender: TObject;
      Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
      var ErrorCode: Integer);
    procedure Edit1Change(Sender: TObject);
    procedure btnSendClick(Sender: TObject);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure Disconnect1Click(Sender: TObject);
    procedure PopupMenu1Popup(Sender: TObject);
    procedure MMServer1Stream(Sender: TObject; Content: Byte;
      Data: TMemoryStream);
    procedure Button5MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Button5MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Panel4Resize(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    CurClient: Integer;
    MaxData: LongInt;
    IniData: DWord;
    
    procedure OpenVideo(Driver: Integer);
    procedure MemoAdd(Msg: String);
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.MemoAdd(Msg: String);
begin
 while memo1.lines.count > 200 do Memo1.Lines.Delete(0);
 Memo1.Lines.Add(Msg);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 TrackBar1.Position := MMServer1.Quality;
 TrackBar2.Position := MMServer1.BandwithTrottle;
 CurClient          := 0;
 Label3.Caption     := '0';
 Edit1.Text         := '';
 MaxData            := 0;

 Memo1.Lines.Clear;

 ComboBox1.Items := MMServer1.Drivers;
 if ComboBox1.Items.count > 0 then begin
  ComboBox1.ItemIndex := 0;
  OpenVideo(ComboBox1.ItemIndex);
 end;

end;

procedure TForm1.ComboBox1Change(Sender: TObject);
begin
 OpenVideo(ComboBox1.ItemIndex);
end;

procedure TForm1.OpenVideo(Driver: Integer);
begin
 MMServer1.OpenVideo(Driver);
 Button1.Enabled := MMServer1.CanDlgVideoFormat;
 Button2.Enabled := MMServer1.CanDlgVideoSource;
 Button3.Enabled := MMServer1.CanDlgVideoCompression;
 Button4.Enabled := MMServer1.CanDlgVideoDisplay;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
 MMServer1.DlgFormat;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
 MMServer1.DlgSource;
end;

procedure TForm1.TrackBar1Change(Sender: TObject);
begin
 MMServer1.Quality := TrackBar1.Position;
end;

procedure TForm1.TrackBar2Change(Sender: TObject);
begin
 MMServer1.BandwithTrottle := TrackBar2.Position;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
 MMServer1.DlgCompression;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
 MMServer1.DlgDisplay;
end;

procedure TForm1.ServerSocketClientConnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
 with ListView.Items.Add do begin
  Caption := IntToStr(Socket.Handle);
  SubItems.Add(Socket.RemoteAddress);
 end;
end;

procedure TForm1.ServerSocketClientDisconnect(Sender: TObject;
  Socket: TCustomWinSocket);
var
 CurItem: TListItem;
begin
 CurItem := ListView.FindCaption(0, IntToStr(Socket.Handle), False, True, False);
 if CurItem <> nil then CurItem.Delete;
end;

procedure TForm1.ServerSocketClientError(Sender: TObject;
  Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
  var ErrorCode: Integer);
begin
 ErrorCode := 0;
end;

procedure TForm1.Edit1Change(Sender: TObject);
begin
 btnSend.Enabled := Edit1.Text <> '';
end;

procedure TForm1.btnSendClick(Sender: TObject);
begin
 MMServer1.AddMessage(Edit1.Text);
 MemoAdd(Edit1.Text);
 Edit1.Text := '';
end;

procedure TForm1.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
 if Key = #13 then begin
  Key := #0;
  btnSendClick(Self);
 end;

end;

procedure TForm1.Disconnect1Click(Sender: TObject);
var
 CurItem: TListItem;
 n, h: Integer;
begin
 CurItem := ListView.Selected;
 if CurItem = nil then exit;

 h := StrToInt(CurItem.Caption);

 for n := ServerSocket.Socket.ActiveConnections -1 downto 0 do
  if ServerSocket.Socket.Connections[n].Handle = h then begin
   ServerSocket.Socket.Connections[n].Close;
   Exit;
  end;

end;

procedure TForm1.PopupMenu1Popup(Sender: TObject);
begin
 Disconnect1.Enabled := ListView.SelCount > 0;
end;

procedure TForm1.MMServer1Stream(Sender: TObject; Content: Byte; Data: TMemoryStream);
var
 MyBuff: Array[0..65000] of Byte;
 i: Integer;
Begin

 Data.Position := 0;
 Data.Read(MyBuff, Data.Size);

 if Content = stVideo then begin
  INC(CurClient);
  if CurClient > ServerSocket.Socket.ActiveConnections -1 then CurClient := 0;

  if CurClient <= ServerSocket.Socket.ActiveConnections -1 then
   try
    ServerSocket.Socket.Connections[CurClient].SendBuf(MyBuff, Data.Size);
   except
   end;
 end else begin
  for i := ServerSocket.Socket.ActiveConnections -1 downto 0 do try
   ServerSocket.Socket.Connections[i].SendBuf(MyBuff, Data.Size);
  except
  end;
 end;

end;

procedure TForm1.Button5MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 MMServer1.VoiceActive := True;
end;

procedure TForm1.Button5MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 MMServer1.VoiceActive := False;
end;

procedure TForm1.Panel4Resize(Sender: TObject);
begin
 btnSend.Left := Panel4.Width -Panel4.BorderWidth - btnSend.Width;
 Edit1.Width  := btnSend.Left - 8;
end;

end.
